-- VIEW: Eer istenirse herhangi bir select sonucu veritabannda dinamik bir grnmde saklanabilir ve
-- bu grnm zerinden select yaplarak zellikle join ve group by sorgularnn tekrar tekrar yazlmasnn nne geilir.

use Filmler

-- Film, Yonetmen ve Tur tablolarn inner join ile birletirelim ve vFilmTurYonetmen adl view'da sorguyu saklayalm:
-- Aadaki rnekte create view'n bandan itibaren sorgu seilerek altrlmaldr 
-- nk create view sorgusu her zaman ilk satr olarak altrlmaldr.
create view vFilmTurYonetmen
as
select f.Id as [Film ID], f.adi as [Film Ad], f.yapimyili as [Film Yapm Yl], f.gisesi as [Film Giesi],
y.Id as [Ynetmen ID], y.adi + ' ' + y.soyadi as [Ynetmen], y.dogumtarihi as [Ynetmen Doum Tarihi], t.adi as [Tr]
from Film f inner join Yonetmen y on f.yonetmenId = y.Id
inner join FilmTur ft on f.Id = ft.filmId
inner join Tur t on ft.turId = t.Id

-- vFilmTurYonetmen view'n oluturduktan sonra istediimiz zaman aadaki gibi view ierisindeki 
-- sorgu zerinden sorgulama yapabiliriz. Ayrca bu view zerinden where, group by ve order by da kullanabiliriz. 
select * from vFilmTurYonetmen where [Film Yapm Yl] is not null order by [Film Ad]

-- stenirse bir view'n sorgusu alter ile deitirilebilir:
-- Aadaki rnekte sorgudan film id'sini kardk. 
-- alter view da create view gibi ilk satr olarak altrlmaldr.
alter view vFilmTurYonetmen
as
select f.adi as [Film Ad], f.yapimyili as [Film Yapm Yl], f.gisesi as [Film Giesi],
y.Id as [Ynetmen ID], y.adi + ' ' + y.soyadi as [Ynetmen], y.dogumtarihi as [Ynetmen Doum Tarihi], t.adi as [Tr]
from Film f inner join Yonetmen y on f.yonetmenId = y.Id
inner join FilmTur ft on f.Id = ft.filmId
inner join Tur t on ft.turId = t.Id

-- stenirse bir view drop ile silinebilir:
drop view vFilmTurYonetmen