-- SELECT FONKSIYONLARI --
-- select ierisinde kullanlan fonksiyonlar where ile de kullanlabilir.
use Filmler
-- Oyuncu adndan soldan 2, soyadndan sadan 4 karakter al ve getir.
-- LEFT: soldan bala, RIGHT: sadan bala.
select LEFT(adi, 2) as adisoldaniki, RIGHT(soyadi, 4) as soyadisagdandort from Oyuncu
-- Oyuncu adnn karakterlerini klt, soyadnn karakterlerini byt.
-- LOWER: harfleri klt, UPPER: harfleri byt.
select LOWER(adi) as adikucuk, UPPER(soyadi) as soyadibuyuk from Oyuncu
-- Oyuncu adnn 2. karakterini getir.
-- SUBSTRING(input parametresi, 
--			 balang karakteri indexi, 
--			 balang karakterinden itibaren ka karakter alaca)
select SUBSTRING(adi,2,1) as ikincikarakter from Oyuncu
-- Oyuncu adn ve soyadn virgl ile birletir, 3. karakter ile (3. karakter dahil) 
-- 7. karakter (7. karakter dahil deil) arasn getir.
-- SQL String'lerde saymaya 1'den balar yani ilk index 1'dir, 0 deil.
select SUBSTRING(adi + ',' + soyadi, 3, 4) as ucilealtiarasi from Oyuncu
-- Oyuncu adn tersten yaz.
select REVERSE(adi) as terstenadi from Oyuncu
-- Oyuncu adn ve soyadn virgl ile birletir, 3. karakter ile (3. karakter dahil) 
-- 7. karakter (7. karakter dahil deil) arasn tersten yazarak getir.
select REVERSE(SUBSTRING(adi + ',' + soyadi, 3, 4)) as terstenucilealtiarasi from Oyuncu
-- LEN: Length.
select adi, LEN(adi) as adikarakteruzunlugu from Oyuncu
-- ROUND: Yuvarla. Parametresi 0 ise virglden nceki deere, 
-- 1 ise virglden sonraki deere yuvarlama yapar.
select ROUND(1.22, 0)
select ROUND(1.66, 0)
select ROUND(1.22, 1)
select ROUND(1.66, 1)
-- SPACE: Boluk brak. Parametresi kadar boluk brakr.
select adi + SPACE(1) + soyadi as adisoyadi from Oyuncu 
select adi + SPACE(20) + soyadi as adisoyadi from Oyuncu
-- Bugnn tarihi ve saati:
select GETDATE() as bugununtarihivesaati
select convert(varchar, getdate(), 104) + ' ' + convert(varchar, getdate(), 24) bugununtarihivesaati -- Trke formatnda bugnn tarihi ve saati
-- Bugnn tarih ve saatine 2 gn eklenmi tarih ve saat:
select DATEADD(day, 2, GETDATE()) as ikigunsonrakitarihvesaat
-- Bugnn tarih ve saatine 3 ay eklenmi tarih ve saat:
select DATEADD(month, 3, GETDATE()) as ucaysonrakitarihvesaat
-- Bugnn tarih ve saatine 4 yl eklenmi tarih ve saat:
select DATEADD(year, 4, GETDATE()) as dortyilsonrakitarihvesaat
-- Bugnn tarih ve saatine 5 saat eklenmi tarih ve saat:
select DATEADD(hour, 5, GETDATE()) as bessaatsonrakitarihvesaat
-- Yln hangi eyreindeyiz?
select DATENAME(QUARTER, GETDATE()) as yilinhangiceyregindeyiz
-- Haftann hangi gnndeyiz?
select DATENAME(WEEKDAY, GETDATE()) as haftaninhangigunundeyiz
-- Yln hangi ayndayz?
select DATENAME(MONTH, GETDATE()) as yilinhangiayindayiz
-- Hangi yldayz?
select DATENAME(YEAR, GETDATE()) as hangiyildayiz
-- Tarih farklarn bulma:
set dateformat dmy
-- tarih (dateformat) formatn belirler. d: gn, m: ay, y: yl.
select DATEDIFF(DAY, '17.05.1980', GETDATE()) as dogumumdanberikacgungecmis
select DATEDIFF(MONTH, '17.05.1980', GETDATE()) as dogumumdanberikacaygecmis
select DATEDIFF(YEAR, '17.05.1980', GETDATE()) as dogumumdanberikacyilgecmis
select DATEDIFF(HOUR, '17.05.1980', GETDATE()) / ((365 * 24) + 6) as yas -- en doru hesap
set dateformat ymd
select DATEPART(DAY, '1980-05-17') -- gn: 17
select DATEPART(MONTH, '1980-05-17') -- ay: 5
select DATEPART(YEAR, '1980-05-17') -- yl: 1980
select DATEPART(HOUR, '1980-05-17 11:58:59') -- saat: 11
select DATEPART(MINUTE, '1980-05-17 11:58:59') -- dakika: 58
select DATEPART(SECOND, '1980-05-17 11:58:59') -- saniye: 59
select DAY(GETDATE()) -- gn
select MONTH(GETDATE()) -- ay
select YEAR(GETDATE()) -- yl
select TRIM(' AIL ALSA ') -- bataki ve sondaki tm bo karakterleri kaldr
select LTRIM(RTRIM(' AIL ALSA ')) -- nce sondaki sonra bataki tm bo karakterleri kaldr
-- ROW_NUMBER()
select * from (
select ROW_NUMBER() over (order by adi) as sira, adi, soyadi from Oyuncu
) tmp
-- where'de fonksiyon kullanmlar
select * from Oyuncu where YEAR(dogumtarihi) >= 1970 and DATEPART(MONTH, dogumtarihi) >= 1 and DAY(dogumtarihi) >= 1
select UPPER(adi) adibuyukharf, UPPER(soyadi) soyadibuyukharf, * from Yonetmen where UPPER(adi) = UPPER('james') and UPPER(soyadi) = UPPER('cameron')
set dateformat dmy
select * from oyuncu where dogumtarihi < '01.01.1970'
select * from oyuncu where dogumtarihi < convert(varchar(10), '1970-01-01', 104)
select * from yonetmen where adi + ' ' + soyadi = ' james cameron ' -- banda ve sonunda boluk olduundan veri dnmez
select * from yonetmen where adi + ' ' + soyadi = trim(' james cameron ')
select * from yonetmen where adi + ' ' + soyadi = trim('     guy ritchie     ')
select * from yonetmen where adi + ' ' + soyadi = ltrim(rtrim('     guy ritchie     '))